#ifndef TEMPUS_CONFIG_HPP
#define TEMPUS_CONFIG_HPP

/* #undef Tempus_DEBUG */
#define HAVE_TEMPUS_EXPLICIT_INSTANTIATION
/* #undef Tempus_ENABLE_MPI */

#ifndef TEMPUS_FUNC_TIME_MONITOR
#  define TEMPUS_TEUCHOS_TIME_MONITOR
#  define TEMPUS_FUNC_TIME_MONITOR(FUNCNAME) \
     TEUCHOS_FUNC_TIME_MONITOR_DIFF(FUNCNAME, TEMPUS)
#  define TEMPUS_FUNC_TIME_MONITOR_DIFF(FUNCNAME, DIFF) \
     TEUCHOS_FUNC_TIME_MONITOR_DIFF(FUNCNAME, DIFF)
#endif

#ifndef TEMPUS_DEPRECATED
#  if (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1))
#    define TEMPUS_DEPRECATED  __attribute__((__deprecated__))
#  else
#    define TEMPUS_DEPRECATED
#  endif
#endif

#ifndef TEMPUS_DEPRECATED_MSG
#  if (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 5))
#    define TEMPUS_DEPRECATED_MSG(MSG)  __attribute__((__deprecated__ (#MSG) ))
#  elif (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1))
#    define TEMPUS_DEPRECATED_MSG(MSG)  __attribute__((__deprecated__))
#  else
#    define TEMPUS_DEPRECATED_MSG(MSG)
#  endif
#endif


#endif
