# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/Piro clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "Piro requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/Piro build
## ---------------------------------------------------------------------------

set(Piro_CXX_COMPILER "/usr/bin/g++")

set(Piro_C_COMPILER "/usr/bin/gcc")

set(Piro_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(Piro_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/Piro build
## ---------------------------------------------------------------------------

## Give the build type
set(Piro_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(Piro_CXX_FLAGS [[ ]])

set(Piro_C_FLAGS [[  -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64  -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -fopenmp ]])

set(Piro_Fortran_FLAGS [[ ]])
# Deprecated
set(Piro_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(Piro_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(Piro_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(Piro_BUILD_SHARED_LIBS "ON")

set(Piro_LINKER /usr/bin/ld)
set(Piro_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(Piro_INSTALL_DIR "/usr")

## List of package include dirs
set(Piro_INCLUDE_DIRS "")

## List of package library paths
set(Piro_LIBRARY_DIRS "")

## List of package libraries
set(Piro_LIBRARIES "Piro::piro;ROL::rol;Stokhos::stokhos_muelu;Stokhos::stokhos_muelu_pce_openmp;Stokhos::stokhos_muelu_mp_16_openmp;Stokhos::stokhos_ifpack2;Stokhos::stokhos_ifpack2_pce_openmp;Stokhos::stokhos_ifpack2_mp_16_openmp;Stokhos::stokhos_amesos2;Stokhos::stokhos_amesos2_mp_16_openmp;Stokhos::stokhos_xpetra;Stokhos::stokhos_xpetra_pce_openmp;Stokhos::stokhos_xpetra_mp_16_openmp;Stokhos::stokhos_tpetra;Stokhos::stokhos_tpetraext_pce_openmp;Stokhos::stokhos_tpetra_pce_openmp;Stokhos::stokhos_tpetra_sd_pce_openmp;Stokhos::stokhos_tpetraext_mp_16_openmp;Stokhos::stokhos_tpetra_mp_16_openmp;Stokhos::stokhos_tpetra_sd_mp_16_openmp;Stokhos::stokhos_sacado;Stokhos::stokhos;Tempus::tempus;Rythmos::rythmos;MueLu::muelu-adapters;MueLu::muelu;NOX::locatpetra;NOX::locathyra;NOX::locaepetra;NOX::localapack;NOX::loca;NOX::noxepetra;NOX::noxlapack;NOX::nox;Intrepid2::intrepid2;Intrepid::intrepid;Teko::teko;Stratimikos::stratimikos;Stratimikos::stratimikosbelos;Stratimikos::stratimikosamesos2;Stratimikos::stratimikosaztecoo;Stratimikos::stratimikosamesos;Stratimikos::stratimikosml;Stratimikos::stratimikosifpack;Ifpack2::ifpack2-adapters;Ifpack2::ifpack2;Anasazi::anasazitpetra;Anasazi::ModeLaplace;Anasazi::anasaziepetra;Anasazi::anasazi;Amesos2::amesos2;ShyLU_NodeTacho::tacho;ShyLU_NodeHTS::shylu_nodehts;Belos::belosxpetra;Belos::belostpetra;Belos::belosepetra;Belos::belos;ML::ml;Ifpack::ifpack;Zoltan2Core::zoltan2;Amesos::amesos;Galeri::galeri-xpetra;Galeri::galeri-epetra;AztecOO::aztecoo;Isorropia::isorropia;Xpetra::xpetra-sup;Xpetra::xpetra;ThyraTpetraAdapters::thyratpetra;ThyraEpetraExtAdapters::thyraepetraext;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TrilinosSS::trilinosss;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;EpetraExt::epetraext;Triutils::triutils;Shards::shards;Zoltan::zoltan;Zoltan::simpi;Epetra::epetra;MiniTensor::minitensor;Sacado::sacado;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(Piro_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(Piro_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(Piro_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;AMD::all_libs;UMFPACK::all_libs;SuperLU::all_libs;HDF5::all_libs;Zlib::all_libs;Scotch::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(Piro_MPI_LIBRARIES "")
set(Piro_MPI_LIBRARY_DIRS "")
set(Piro_MPI_INCLUDE_DIRS "")
set(Piro_MPI_EXEC "")
set(Piro_MPI_EXEC_MAX_NUMPROCS "")
set(Piro_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(Piro_PACKAGE_LIST "Piro;ROL;Stokhos;Tempus;Rythmos;MueLu;NOX;Intrepid2;Intrepid;Teko;Stratimikos;Ifpack2;Anasazi;Amesos2;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Ifpack;Zoltan2Core;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;EpetraExt;Triutils;Shards;Zoltan;Epetra;MiniTensor;Sacado;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(Piro_TPL_LIST "DLlib;Eigen;AMD;UMFPACK;SuperLU;HDF5;Zlib;Scotch;Boost;LAPACK;BLAS;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(Piro_ENABLE_Teuchos ON)
set(Piro_ENABLE_Stratimikos ON)
set(Piro_ENABLE_ThyraCore ON)
set(Piro_ENABLE_NOX ON)
set(Piro_ENABLE_Rythmos ON)
set(Piro_ENABLE_Tempus ON)
set(Piro_ENABLE_Stokhos ON)
set(Piro_ENABLE_TriKota OFF)
set(Piro_ENABLE_ROL ON)
set(Piro_ENABLE_Ifpack2 ON)
set(Piro_ENABLE_MueLu ON)
set(Piro_ENABLE_ThyraEpetraAdapters ON)
set(Piro_ENABLE_ThyraEpetraExtAdapters ON)
set(Piro_ENABLE_Epetra ON)
set(Piro_ENABLE_EpetraExt ON)
set(Piro_ENABLE_Tpetra ON)
set(Piro_ENABLE_Teko ON)

# Exported cache variables

# Include configuration of dependent packages
if (NOT TARGET Teuchos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
endif()
if (NOT TARGET Stratimikos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Stratimikos/StratimikosConfig.cmake")
endif()
if (NOT TARGET ThyraCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraCore/ThyraCoreConfig.cmake")
endif()
if (NOT TARGET NOX::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../NOX/NOXConfig.cmake")
endif()
if (NOT TARGET Rythmos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Rythmos/RythmosConfig.cmake")
endif()
if (NOT TARGET Tempus::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tempus/TempusConfig.cmake")
endif()
if (NOT TARGET Stokhos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Stokhos/StokhosConfig.cmake")
endif()
if (NOT TARGET ROL::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ROL/ROLConfig.cmake")
endif()
if (NOT TARGET Ifpack2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
endif()
if (NOT TARGET MueLu::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../MueLu/MueLuConfig.cmake")
endif()
if (NOT TARGET ThyraEpetraAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraAdapters/ThyraEpetraAdaptersConfig.cmake")
endif()
if (NOT TARGET ThyraEpetraExtAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraExtAdapters/ThyraEpetraExtAdaptersConfig.cmake")
endif()
if (NOT TARGET Epetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Epetra/EpetraConfig.cmake")
endif()
if (NOT TARGET EpetraExt::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../EpetraExt/EpetraExtConfig.cmake")
endif()
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()
if (NOT TARGET Teko::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teko/TekoConfig.cmake")
endif()

# Import Piro targets
include("${CMAKE_CURRENT_LIST_DIR}/PiroTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(Piro_EXPORTED_PACKAGE_LIBS_NAMES "piro")

foreach(libname IN LISTS Piro_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE Piro::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'Piro::${libname}', or better yet,"
      " 'Piro::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'Piro'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'Piro_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
