# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/TeuchosRemainder clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "TeuchosRemainder requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/TeuchosRemainder build
## ---------------------------------------------------------------------------

set(TeuchosRemainder_CXX_COMPILER "/usr/bin/g++")

set(TeuchosRemainder_C_COMPILER "/usr/bin/gcc")

set(TeuchosRemainder_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(TeuchosRemainder_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/TeuchosRemainder build
## ---------------------------------------------------------------------------

## Give the build type
set(TeuchosRemainder_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(TeuchosRemainder_CXX_FLAGS [[ ]])

set(TeuchosRemainder_C_FLAGS [[  -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64  -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -fopenmp ]])

set(TeuchosRemainder_Fortran_FLAGS [[ ]])
# Deprecated
set(TeuchosRemainder_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(TeuchosRemainder_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(TeuchosRemainder_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(TeuchosRemainder_BUILD_SHARED_LIBS "ON")

set(TeuchosRemainder_LINKER /usr/bin/ld)
set(TeuchosRemainder_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(TeuchosRemainder_INSTALL_DIR "/usr")

## List of package include dirs
set(TeuchosRemainder_INCLUDE_DIRS "")

## List of package library paths
set(TeuchosRemainder_LIBRARY_DIRS "")

## List of package libraries
set(TeuchosRemainder_LIBRARIES "TeuchosRemainder::teuchosremainder;TeuchosCore::teuchoscore;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(TeuchosRemainder_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(TeuchosRemainder_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(TeuchosRemainder_TPL_LIBRARIES "DLlib::all_libs;Boost::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(TeuchosRemainder_MPI_LIBRARIES "")
set(TeuchosRemainder_MPI_LIBRARY_DIRS "")
set(TeuchosRemainder_MPI_INCLUDE_DIRS "")
set(TeuchosRemainder_MPI_EXEC "")
set(TeuchosRemainder_MPI_EXEC_MAX_NUMPROCS "")
set(TeuchosRemainder_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(TeuchosRemainder_PACKAGE_LIST "TeuchosRemainder;TeuchosCore;KokkosCore")

## The TPLs enabled for this project
set(TeuchosRemainder_TPL_LIST "DLlib;Boost;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(TeuchosRemainder_ENABLE_TeuchosCore ON)

# Exported cache variables
set(Teuchos_ENABLE_DEBUG "OFF")
set(HAVE_TEUCHOS_DEBUG "OFF")
set(Teuchos_ENABLE_EXPLICIT_INSTANTIATION "ON")
set(HAVE_TEUCHOS_EXPLICIT_INSTANTIATION "ON")
set(Teuchos_ENABLE_LONG_DOUBLE "FALSE")
set(HAVE_TEUCHOS_LONG_DOUBLE "OFF")
set(Teuchos_ENABLE_FLOAT "TRUE")
set(HAVE_TEUCHOS_FLOAT "ON")
set(Teuchos_ENABLE_COMPLEX "ON")
set(HAVE_TEUCHOS_COMPLEX "ON")
set(Teuchos_INST_FLOAT "TRUE")
set(HAVE_TEUCHOS_INST_FLOAT "ON")
set(Teuchos_INST_COMPLEX_FLOAT "ON")
set(HAVE_TEUCHOS_INST_COMPLEX_FLOAT "ON")
set(Teuchos_INST_COMPLEX_DOUBLE "TRUE")
set(HAVE_TEUCHOS_INST_COMPLEX_DOUBLE "ON")
set(Teuchos_ENABLE_THREAD_SAFE "OFF")
set(HAVE_TEUCHOS_THREAD_SAFE "OFF")
set(Teuchos_ENABLE_ABC "OFF")
set(HAVE_TEUCHOS_ARRAY_BOUNDSCHECK "OFF")
set(Teuchos_ENABLE_DEBUG_RCP_NODE_TRACING "OFF")
set(HAVE_TEUCHOS_DEBUG_RCP_NODE_TRACING "OFF")
set(Teuchos_ENABLE_EXTENDED "ON")
set(HAVE_TEUCHOS_EXTENDED "ON")
set(Teuchos_ENABLE_C_EXCEPTIONS "OFF")
set(HAVE_TEUCHOS_C_EXCEPTIONS "OFF")
set(Teuchos_ENABLE_GCC_DEMANGLE "ON")
set(HAVE_TEUCHOS_DEMANGLE "ON")
set(Teuchos_ENABLE_STACKED_TIMER_IN_TIME_MONITOR "ON")
set(HAVE_TEUCHOS_ADD_TIME_MONITOR_TO_STACKED_TIMER "ON")
set(Teuchos_GLOBALLY_REDUCE_UNITTEST_RESULTS "OFF")
set(HAVE_TEUCHOS_GLOBALLY_REDUCE_UNITTEST_RESULTS "OFF")
set(Teuchos_KOKKOS_PROFILING "ON")
set(HAVE_TEUCHOS_KOKKOS_PROFILING "ON")
set(Trilinos_ENABLE_LINEAR_SOLVER_FACTORY_REGISTRATION "ON")
set(TRILINOS_HAVE_LINEAR_SOLVER_FACTORY_REGISTRATION "ON")

# Include configuration of dependent packages
if (NOT TARGET TeuchosCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../TeuchosCore/TeuchosCoreConfig.cmake")
endif()

# Import TeuchosRemainder targets
include("${CMAKE_CURRENT_LIST_DIR}/TeuchosRemainderTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(TeuchosRemainder_EXPORTED_PACKAGE_LIBS_NAMES "teuchosremainder")

foreach(libname IN LISTS TeuchosRemainder_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE TeuchosRemainder::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'TeuchosRemainder::${libname}', or better yet,"
      " 'TeuchosRemainder::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'TeuchosRemainder'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'TeuchosRemainder_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
