# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/ThyraTpetraAdapters clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "ThyraTpetraAdapters requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/ThyraTpetraAdapters build
## ---------------------------------------------------------------------------

set(ThyraTpetraAdapters_CXX_COMPILER "/usr/bin/g++")

set(ThyraTpetraAdapters_C_COMPILER "/usr/bin/gcc")

set(ThyraTpetraAdapters_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(ThyraTpetraAdapters_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/ThyraTpetraAdapters build
## ---------------------------------------------------------------------------

## Give the build type
set(ThyraTpetraAdapters_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(ThyraTpetraAdapters_CXX_FLAGS [[ ]])

set(ThyraTpetraAdapters_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64  -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -fopenmp ]])

set(ThyraTpetraAdapters_Fortran_FLAGS [[ ]])
# Deprecated
set(ThyraTpetraAdapters_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(ThyraTpetraAdapters_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(ThyraTpetraAdapters_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(ThyraTpetraAdapters_BUILD_SHARED_LIBS "ON")

set(ThyraTpetraAdapters_LINKER /usr/bin/ld)
set(ThyraTpetraAdapters_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(ThyraTpetraAdapters_INSTALL_DIR "/usr")

## List of package include dirs
set(ThyraTpetraAdapters_INCLUDE_DIRS "")

## List of package library paths
set(ThyraTpetraAdapters_LIBRARY_DIRS "")

## List of package libraries
set(ThyraTpetraAdapters_LIBRARIES "ThyraTpetraAdapters::thyratpetra;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;Epetra::epetra;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(ThyraTpetraAdapters_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(ThyraTpetraAdapters_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(ThyraTpetraAdapters_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;SuperLU::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(ThyraTpetraAdapters_MPI_LIBRARIES "")
set(ThyraTpetraAdapters_MPI_LIBRARY_DIRS "")
set(ThyraTpetraAdapters_MPI_INCLUDE_DIRS "")
set(ThyraTpetraAdapters_MPI_EXEC "")
set(ThyraTpetraAdapters_MPI_EXEC_MAX_NUMPROCS "")
set(ThyraTpetraAdapters_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(ThyraTpetraAdapters_PACKAGE_LIST "ThyraTpetraAdapters;ThyraEpetraAdapters;ThyraCore;Tpetra;TpetraCore;TpetraTSQR;Epetra;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(ThyraTpetraAdapters_TPL_LIST "DLlib;Eigen;SuperLU;Boost;LAPACK;BLAS;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(ThyraTpetraAdapters_ENABLE_ThyraCore ON)
set(ThyraTpetraAdapters_ENABLE_Tpetra ON)
set(ThyraTpetraAdapters_ENABLE_ThyraEpetraAdapters ON)

# Exported cache variables
set(Thyra_ENABLE_DEBUG "OFF")
set(HAVE_THYRA_DEBUG "OFF")
set(Thyra_ENABLE_EXPLICIT_INSTANTIATION "ON")
set(HAVE_THYRA_EXPLICIT_INSTANTIATION "ON")
set(Thyra_ENABLE_ME_POLYNOMIAL "ON")
set(HAVE_THYRA_ME_POLYNOMIAL "ON")
set(Thyra_ENABLE_HESSIAN_SUPPORT "ON")
set(Thyra_BUILD_HESSIAN_SUPPORT "ON")

# Include configuration of dependent packages
if (NOT TARGET ThyraCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraCore/ThyraCoreConfig.cmake")
endif()
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()
if (NOT TARGET ThyraEpetraAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraAdapters/ThyraEpetraAdaptersConfig.cmake")
endif()

# Import ThyraTpetraAdapters targets
include("${CMAKE_CURRENT_LIST_DIR}/ThyraTpetraAdaptersTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(ThyraTpetraAdapters_EXPORTED_PACKAGE_LIBS_NAMES "thyratpetra")

foreach(libname IN LISTS ThyraTpetraAdapters_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE ThyraTpetraAdapters::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'ThyraTpetraAdapters::${libname}', or better yet,"
      " 'ThyraTpetraAdapters::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'ThyraTpetraAdapters'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'ThyraTpetraAdapters_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
