# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/TrilinosInstallTests clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "TrilinosInstallTests requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/TrilinosInstallTests build
## ---------------------------------------------------------------------------

set(TrilinosInstallTests_CXX_COMPILER "/usr/bin/g++")

set(TrilinosInstallTests_C_COMPILER "/usr/bin/gcc")

set(TrilinosInstallTests_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(TrilinosInstallTests_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/TrilinosInstallTests build
## ---------------------------------------------------------------------------

## Give the build type
set(TrilinosInstallTests_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(TrilinosInstallTests_CXX_FLAGS [[ ]])

set(TrilinosInstallTests_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -m64  -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -w -fopenmp ]])

set(TrilinosInstallTests_Fortran_FLAGS [[ ]])
# Deprecated
set(TrilinosInstallTests_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(TrilinosInstallTests_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(TrilinosInstallTests_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(TrilinosInstallTests_BUILD_SHARED_LIBS "ON")

set(TrilinosInstallTests_LINKER /usr/bin/ld)
set(TrilinosInstallTests_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(TrilinosInstallTests_INSTALL_DIR "/usr")

## List of package include dirs
set(TrilinosInstallTests_INCLUDE_DIRS "")

## List of package library paths
set(TrilinosInstallTests_LIBRARY_DIRS "")

## List of package libraries
set(TrilinosInstallTests_LIBRARIES "TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;Epetra::epetra;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(TrilinosInstallTests_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(TrilinosInstallTests_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(TrilinosInstallTests_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;SuperLU::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(TrilinosInstallTests_MPI_LIBRARIES "")
set(TrilinosInstallTests_MPI_LIBRARY_DIRS "")
set(TrilinosInstallTests_MPI_INCLUDE_DIRS "")
set(TrilinosInstallTests_MPI_EXEC "")
set(TrilinosInstallTests_MPI_EXEC_MAX_NUMPROCS "")
set(TrilinosInstallTests_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(TrilinosInstallTests_PACKAGE_LIST "Tpetra;TpetraCore;TpetraTSQR;Epetra;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(TrilinosInstallTests_TPL_LIST "DLlib;Eigen;SuperLU;Boost;LAPACK;BLAS;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(TrilinosInstallTests_ENABLE_Tpetra ON)

# Exported cache variables

# Include configuration of dependent packages
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()

# Import TrilinosInstallTests targets
include("${CMAKE_CURRENT_LIST_DIR}/TrilinosInstallTestsTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(TrilinosInstallTests_EXPORTED_PACKAGE_LIBS_NAMES "")

foreach(libname IN LISTS TrilinosInstallTests_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE TrilinosInstallTests::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'TrilinosInstallTests::${libname}', or better yet,"
      " 'TrilinosInstallTests::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'TrilinosInstallTests'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'TrilinosInstallTests_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
